;Entradas: lee clave de 3 bits en los dip switches SW3SW1, (n= 0...7). 
;Salidas: realizar corrimientos con un led encendido de B0 a B7 y repite. 
;No incluir el carry en los corrimientos. 
;Establecer la velocidad del corrimiento de acuerdo a la clave n, siendo 
;n=7 para la velocidad ms lenta (aprox. 1.4 segundos por cada corrimiento) 
;y n=0 la ms rpida (aprox. 200 ms. por corrimiento)
;para modificar el valor de los dip switches, debe darse reset al sistema.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ 	H'82'
CLAVE100	equ H'83'	;valor de dip switch
AUX			equ H'84'	;localidad auxiliar
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		BOLTSWITCH
		incf	CLAVE100
		movlw	1
		movwf	PORTB
repeat	call	delay
		rlncf	PORTB,f
		goto	repeat

delay	movf	CLAVE100,w	;subrutina de delay variable
		movwf	AUX
loop	call 	retrobolt
		decfsz	AUX,f
		goto	loop
		return


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'12'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

