;Realice un programa que almacene en localidades de la memoria de cdigo del 
;microcontrolador una tabla T[n] mediante las instrucciones retlw, con los 
;siguientes 8 datos hexadecimales  16 nibbles: 

;         Nibble 0						nibble 15
;  Inicio tabla - 8E 3F AD 29 60 14 B7 C5

;Lea de los dip switches un valor n (0 a F). Escriba en el puerto B, con retraso
;de 1 segundo, cada uno de los nibbles de la tabla, en este caso 8,E,3,F,A,D, etc. 
;Cuando exista una coincidencia entre n y alguno de los valores de la tabla, 
;los leds permanecern mostrando ese valor. Para repetir la operacin debe darse
;reset.

	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J		equ	H'80'
K		equ	H'81'
L		equ	H'82'
NIBBLE	equ	H'83'
CLAVE100 equ H'84'
CONTADOR equ H'85'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		BOLTSWITCH
		movlw	9
		movwf	PCLATH		;inicializa la parte alta del PC para tabla
		clrf	CONTADOR
malla:	movf	CONTADOR,w
		call 	tabla		;regresa con dato en w
		movwf	NIBBLE
		swapf	NIBBLE,w
		andlw	0xF
		movwf	PORTB
		movf	CLAVE100,w
		xorwf	PORTB,w
		btfss	STATUS,Z
		goto	sigue
		sleep
sigue:	call	retrobolt
		movf	NIBBLE,w
		andlw	0xF
		movwf	PORTB
		movf	CLAVE100,w
		xorwf	PORTB,w
		btfss	STATUS,Z
		goto	sigue8
		sleep
sigue8:	call 	retrobolt		
		incf	CONTADOR,f
		incf	CONTADOR,f
		movlw	D'16'
		xorwf	CONTADOR,w
		btfss	STATUS,Z
		goto	malla
		sleep

		ORG 0X900
tabla:  addwf	PCL			;8E 3F AD 29 60 14 B7 C5
		retlw	0x8E
		retlw	0x3F
		retlw	0xAD
		retlw	0x29
		retlw	0x60
		retlw	0x14
		retlw	0xB7
		retlw	0xC5

;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'61'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return

end