;Realice un programa que almacene en localidades 
;de la memoria de cdigo del microcontrolador una 
;tabla mediante las instrucciones retlw, con los 
;siguientes 8 datos hexadecimales: 
;59 2B FC AE D9 66 1B 95
;Muestre en los leds, LED7..LED0 en cdigo binario, 
;en forma consecutiva, durante 2 segundos, cada uno 
;de los valores pares de la tabla si SW1=ON, y cada 
;valor de los nones si SW1=OFF. 
;Programa termina con instruccin sleep.
;Por ejemplo, si SW1=OFF, se mostrarn los valores 
;nones, es decir: 59,2B,D9,1B,95 
;Nota importante: el programa deber funcionar igualmente 
;con valores distintos en la tabla.


	processor 18F2550
	include	  <p18F2550.inc>
	include	 "KEYBOLT2.inc"	;ARCHIVO AUXILIAR CONTIENE MACRO Y DEFINE

J	equ	H'80'	  
K	equ	H'81'
L	equ H'82'
contador EQU H'83'
valor	 EQU h'84'
	 
		org 	0x800	;MODIFIQUE A ORG=0 PARA SIMULAR EN MPLAB
		PUERTOS
		movlw	9
		movwf	PCLATH	;INICIALIZA PARA EL MANEJO DE LA TABLA
		clrf 	contador
		btfss	SW1
		goto	par
		goto	non
non:	movf	contador,w
		call	tabla
		movwf	valor
		btfss	valor,0
		goto	omite1
		movwf	PORTB			;valor es non
		call	retrobolt
		call 	retrobolt
omite1:	incf	contador,f
		incf	contador,f
		movlw	0x10
		xorwf	contador,w
		btfss	STATUS,Z
		goto	non
		sleep
par:	movf	contador,w
		call	tabla
		movwf	valor
		btfsc	valor,0
		goto	omite2
		movwf	PORTB			;valor es par
		call	retrobolt
		call	retrobolt
omite2:	incf	contador,f
		incf	contador,f
		movlw	0x10
		xorwf	contador,w
		btfss	STATUS,Z
		goto	par
		sleep
	
		

		org		0x900		;59 2B FC AE D9 66 1B 95
tabla:	addwf	PCL,f
		retlw	H'59'
		retlw	H'2B'
		retlw	H'FC'
		retlw	H'AE'
		retlw	H'D9'
		retlw	H'66'
		retlw	H'1B'
		retlw	H'95'


;SUBRUTINA DE RETRASO APROX DE 1 SEGUNDO.SE PUEDE MODIFICAR A (16.4 x L) MILISEGUNDOS

retrobolt:	movlw	D'61'	;valor de L. Modifique para cambiar el valor del retraso.
		movwf	L
lloop		movlw	D'255'	; w := 200 decimal
		movwf	J	; J := w
jloop:		movwf	K	; K := w
kloop:		decfsz	K,f	; K = K-1, skip next if zero
		goto 	kloop
		decfsz	J,f	; J = J-1, skip next if zero
		goto	jloop
		decfsz	L,f
		goto	lloop
		return


		end	

